/*

 PMT calib analysis program
 Produced by Hiroshi Ito in 2016.12.16
 How to use
 $root -l PMTcalib.cxx
 
 Environment:
    ROOT ver. 5.34
    C++ compiler
    OS MAC or Linux

*/
void PMTcalib(){
  int i=0;
  int data;
    char name[100];
  vector <double> num;
  vector <double> error;
  vector <double> ped;
  vector <double> pederror;

  f=new TFile("PMTcalib.root","recreate");
  c1=new TCanvas("c1");
  gSystem->ProcessEvents();
  c1->Divide(3,2);

  //
  // raw-data compiling
  //
  c1->cd(1)->SetLogy();
    int jj=0;
for(int ii=110;ii<=150;ii++){
   if(ii>=130 && ii<=138) continue;
  sprintf(name,"wc -l data/run%05d.cmd|cat > .lg",ii);
  system(name);
  ifstream lg(".lg");
  int loopmax;
  lg>>loopmax;
  lg.close();
  sprintf(name,"data/run%05d.cmd",ii);
  ifstream ifs(name);
  sprintf(name,"h%d",jj);
  hist=new TH1F(name,name,1e3,0,1e3);
  for(int i=0;i<loopmax;i++){
    ifs>>data;
    hist->Fill(data);
    for(int j=0;j<16*5-1;j++)
      ifs>>data;
  }
  ifs.close();
  hist->GetXaxis()->SetRangeUser(80,300);
  hist->Draw();
  hist->Fit("gaus","Q","",ped(jj,0),ped(jj,1));
  //cout<<ped(jj,0)<<" "<<ped(jj,1)<<" ";
  ped.push_back(gaus->GetParameter(1));
  pederror.push_back(gaus->GetParameter(2));
  if(oph(jj,0) !=0){
    hist->Fit("gaus","Q+","",oph(jj,0),oph(jj,1));
      num.push_back(gaus->GetParameter(1));
      error.push_back(gaus->GetParameter(2));
  }
  else{
      num.push_back(0);
      error.push_back(0);
  }
  //cout<<oph(jj,0)<<" "<<oph(jj,1)<<endl;
  c1->Update();
  jj++;
}
    
//
// PMT 1 : H1161 RA6865
//
    vector <double> gain;
    vector <double> gerror;
    vector <double> mean;
    vector <double> er_sys;
    vector <double> er_stat;
    double dmy[100]={0};
for(int j=0;j<5;j++){
    dmy[0]=0;
    dmy[1]=0;
  for(int i=0;i<4;i++){
   // cout<<ped[i+4*j]<<" "<<pederror[i+4*j]<<" "<<num[i+4*j]
    //    <<" "<<error[i+4*j]<<endl;
      if(num[i+4*j]!=0){
          gain.push_back((num[i+4*j] - ped[i+4*j])*gain_c(0)/ele());
          dmy[0]+=(num[i+4*j] - ped[i+4*j])*gain_c(0)/ele();
          if(dmy[1]<(error[i+4*j]+error[i+4*j])*gain_c(0)/ele()/sqrt(1e4))
              dmy[1]=(error[i+4*j]+error[i+4*j])*gain_c(0)/ele()/sqrt(1e4);
      }
    }
    mean.push_back(dmy[0]/3);
    dmy[0]=0;
    for(int i=0;i<3;i++)
        dmy[0]+=((mean[j]-gain[i+j*3])**2);
    er_sys.push_back(sqrt(dmy[0]/3));
    er_stat.push_back(dmy[1]);
}
    
cout<<">>>>>>>>>>\n";
int n=5;
double x[10]={2300,2400,2500,2600,2700};
double y[10]={0},elx[10]={1,1,1,1,1},ely[10]={0};
for(int j=0;j<5;j++){
    //for(int i=0;i<3;i++){
    //    cout<<gain[i+j*3]<<" "<<gerror[i+3*j]<<endl;
    //}
    cout<<"[]"<<mean[j]<<" "<<er_stat[j]<<" "<<er_sys[j]<<endl;
    y[j]=mean[j];
    ely[j]=sqrt(er_stat[j]**2+er_sys[j]**2);
}
    cout<<"debug"<<flush;
    c1->cd(1)->SetLogy();
    graph=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    graph->SetTitle("H1161 RA6865");
    graph->GetXaxis()->SetTitle("Supplied Voltage (V)");
    graph->GetYaxis()->SetTitle("Gain: #mu(V)");
    graph->SetMarkerStyle(7);
    graph->GetHistogram()->SetMaximum(2e8);
    graph->GetHistogram()->SetMinimum(9e6);
    graph->Draw("ap");
    func=new TF1("func","[0]*x**[1]");
    func->SetParameters(2.5e-13,5.9);
    graph->Fit("func","","",2200,2800);
    graph->Write("pmt1hvgain");
    
    for(int i=0;i<5;i++){
        y[i]=(graph->GetY()[i]-func(x[i]))/func(x[i]);
        ely[i]=graph->GetEYhigh()[i]/func(x[i]);
    }
    c1->cd(2);
    reso=graph=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    reso->SetTitle("Accuracy: H1161 RA6865");
    reso->GetXaxis()->SetTitle("Supplied Voltage (V)");
    reso->GetYaxis()->SetTitle("#Delta #mu / #mu");
    reso->SetMarkerStyle(7);
    reso->GetHistogram()->SetMaximum(0.5);
    reso->GetHistogram()->SetMinimum(-0.5);
    reso->Draw("ap");
    line=new TLine(reso->GetXaxis()->GetXmin(),0,
                   reso->GetXaxis()->GetXmax(),0);
    line->SetLineColor(2);
    line->Draw("same");

    c1->cd(3)->SetLogy();
    jj=0;
    //string a;
    for(int i=0;i<20;i++){
        if(num[i]==0){
            sprintf(name,"h%d",i);
            hist=(TH1F*)f->Get(name);
            hist->Draw();
            c1->Update();
            hist->GetXaxis()->SetRangeUser(ped[jj]+0.5*gain[jj]/gain_c(0)*ele(),
                                           hist->GetXaxis()->GetXmax());
            y[jj]=hist->Integral()/hist->GetEntries();
            ely[jj]=sqrt(hist->Integral())/hist->GetEntries();
            hist->Draw();
            c1->Update();
            cout<<ped[jj]+0.5*gain[jj]/gain_c(0)*ele()<<" "<<y[jj]<<" "<<ely[jj]<<endl<<flush;
//            cin >> a;
            jj++;
        }
    }
    noise=graph=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    noise->SetTitle("Noise ratio: H1161 RA6865");
    noise->GetXaxis()->SetTitle("Supplied Voltage (V)");
    noise->GetYaxis()->SetTitle("Noise ratio");
    noise->SetMarkerStyle(7);
    noise->GetHistogram()->SetMaximum(0.05);
    noise->GetHistogram()->SetMinimum(0.005);
    noise->Draw("ap");

    
    //
    // PMT 2 : H1161 2''PMT Arr'y Z02320
    //
    for(int j=5;j<8;j++){
        dmy[0]=0;
        dmy[1]=0;
        for(int i=0;i<4;i++){
            // cout<<ped[i+4*j]<<" "<<pederror[i+4*j]<<" "<<num[i+4*j]
            //    <<" "<<error[i+4*j]<<endl;
            if(num[i+4*j]!=0){
                gain.push_back((num[i+4*j] - ped[i+4*j])*gain_c(0)/ele());
                dmy[0]+=(num[i+4*j] - ped[i+4*j])*gain_c(0)/ele();
                if(dmy[1]<(error[i+4*j]+error[i+4*j])*gain_c(0)/ele()/sqrt(1e4))
                    dmy[1]=(error[i+4*j]+error[i+4*j])*gain_c(0)/ele()/sqrt(1e4);
            }
        }
        mean.push_back(dmy[0]/3);
        dmy[0]=0;
        for(int i=0;i<3;i++)
            dmy[0]+=((mean[j]-gain[i+j*3])**2);
        er_sys.push_back(sqrt(dmy[0]/3));
        er_stat.push_back(dmy[1]);
    }
    
    cout<<">>>>>>>>>>\n";
    int n=3;
    x[0]=2400;x[1]=2500;x[2]=2600;
    jj=0;
    for(int j=5;j<8;j++){
        cout<<"[]"<<mean[j]<<" "<<er_stat[j]<<" "<<er_sys[j]<<endl;
        y[jj]=mean[j];
        ely[jj]=sqrt(er_stat[j]**2+er_sys[j]**2);
        elx[jj]=1;
        jj++;
    }
    
    c1->cd(4)->SetLogy();
    graph2=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    graph2->SetTitle("H1161 2''PMT Arr'y Z02320");
    graph2->GetXaxis()->SetTitle("Supplied Voltage (V)");
    graph2->GetYaxis()->SetTitle("Gain");
    graph2->GetHistogram()->SetMaximum(2e8);
    graph2->GetHistogram()->SetMinimum(9e6);
    graph2->SetMarkerStyle(7);
    graph2->Draw("ap");
    func2=new TF1("func2","[0]*x**[1]");
    func2->SetParameters(2.5e-13,5.9);
    graph2->Fit("func2","","",2200,2800);
    graph2->Write("pmt2hvgain");

    for(int i=0;i<3;i++){
        y[i]=(graph2->GetY()[i]-func2(x[i]))/func2(x[i]);
        ely[i]=graph2->GetEYhigh()[i]/func2(x[i]);
        cout<<graph2->GetY()[i]<<" "<<func2(x[i])<<" "<<y[i]<<endl;
    }
    c1->cd(5);
    reso2=graph=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    reso2->SetTitle("Accuracy: H1161 2''PMT Arr'y Z02320");
    reso2->GetXaxis()->SetTitle("Supplied Voltage (V)");
    reso2->GetYaxis()->SetTitle("#Delta #mu / #mu");
    reso2->SetMarkerStyle(7);
    reso2->GetHistogram()->SetMaximum(0.5);
    reso2->GetHistogram()->SetMinimum(-0.5);
    reso2->Draw("ap");
    line=new TLine(reso2->GetXaxis()->GetXmin(),0,
                   reso2->GetXaxis()->GetXmax(),0);
    line->SetLineColor(2);
    line->Draw("same");

    
    c1->cd(6)->SetLogy();
    jj=0;
    for(int i=20;i<32;i++){
        if(num[i]==0){
            sprintf(name,"h%d",i);
            hist=(TH1F*)f->Get(name);
            hist->Draw();
            c1->Update();
            hist->GetXaxis()->SetRangeUser(
                            ped[jj+5]+0.5*gain[jj+5]/gain_c(0)*ele(),
                            hist->GetXaxis()->GetXmax());
            y[jj]=hist->Integral()/hist->GetEntries();
            ely[jj]=sqrt(hist->Integral())/hist->GetEntries();
            hist->Draw();
            c1->Update();
            cout<<ped[jj+5]+0.5*gain[jj+5]/gain_c(0)*ele()<<" "<<y[jj]<<" "<<ely[jj]<<endl<<flush;
            jj++;
        }
    }
    noise=graph=new TGraphAsymmErrors(n,x,y,elx,elx,ely,ely);
    noise->SetTitle("Noise ratio: H1161 2''PMT Arr'y Z02320");
    noise->GetXaxis()->SetTitle("Supplied Voltage (V)");
    noise->GetYaxis()->SetTitle("Noise ratio");
    noise->SetMarkerStyle(7);
    noise->GetHistogram()->SetMaximum(1e-3);
    noise->GetHistogram()->SetMinimum(5e-5);
    noise->Draw("ap");
    
    c1->Print("PMTcalib.pdf");
    
  return;
}




double ele(){
    return 1.6021766e-19;
}

double gain_c(int ch){//CAMAC ADC S/N4754
    double num[]={
        0.248122,0.258854,0.244737,0.25969,
        0.245055,0.259868,0.221836,0.243842,
        0.249833,0.261638,0.24576,0.259625,
        0.288513,0.27615,0.250267,0.262141
    };
    return num[ch]*1e-12;
}

double ped(int run,int mod){
    double num[100][2]={
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112},{108,112},{108,112},
        {108,112},{108,112}
    };
    return num[run][mod];
}

double oph(int run,int mod){
    double num2[100][2]={
        {120,135}, {120,135}, {120,135}, {0,0},
        {0,0}, {130,150}, {125,155}, {120,150},
        {120,160}, {120,160}, {120,160}, {0,0},
        {0,0}, {130,180}, {130,180}, {130,180},
        {150,200}, {140,210}, {130,220}, {0,0},
        {115,140}, {115,140}, {115,140}, {0,0},
        {0,0}, {115,150}, {120,150}, {120,140},
        {120,150}, {120,155}, {120,150}, {0,0}
    };
    return num2[run][mod];
}



